package com.izouma.jiashanxia.web;

import com.izouma.jiashanxia.domain.UserSet;
import com.izouma.jiashanxia.service.UserSetService;
import com.izouma.jiashanxia.dto.PageQuery;
import com.izouma.jiashanxia.exception.BusinessException;
import com.izouma.jiashanxia.repo.UserSetRepo;
import com.izouma.jiashanxia.utils.ObjUtils;
import com.izouma.jiashanxia.utils.SecurityUtils;
import com.izouma.jiashanxia.utils.excel.ExcelUtils;
import lombok.AllArgsConstructor;
import org.springframework.data.domain.Page;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.List;

@RestController
@RequestMapping("/userSet")
@AllArgsConstructor
public class UserSetController extends BaseController {
    private UserSetService userSetService;
    private UserSetRepo    userSetRepo;

    //@PreAuthorize("hasRole('ADMIN')")
    @PostMapping("/save")
    public UserSet save(@RequestBody UserSet record) {
        if (record.getId() != null) {
            UserSet orig = userSetRepo.findById(record.getId()).orElseThrow(new BusinessException("无记录"));
            ObjUtils.merge(orig, record);
            return userSetRepo.save(orig);
        }
        return userSetRepo.save(record);
    }


    //@PreAuthorize("hasRole('ADMIN')")
    @PostMapping("/all")
    public Page<UserSet> all(@RequestBody PageQuery pageQuery) {
        return userSetService.all(pageQuery);
    }

    @GetMapping("/get/{id}")
    public UserSet get(@PathVariable Long id) {
        return userSetRepo.findById(id).orElseThrow(new BusinessException("无记录"));
    }

    @PostMapping("/del/{id}")
    public void del(@PathVariable Long id) {
        userSetRepo.softDelete(id);
    }

    @GetMapping("/excel")
    @ResponseBody
    public void excel(HttpServletResponse response, PageQuery pageQuery) throws IOException {
        List<UserSet> data = all(pageQuery).getContent();
        ExcelUtils.export(response, data);
    }

    @GetMapping("/my")
    public List<UserSet> my() {
        return userSetRepo.findAllByUserId(SecurityUtils.getAuthenticatedUser().getId());
    }
}

